// Code generated by BobGen psql v0.22.0. DO NOT EDIT.
// This file is meant to be re-generated in place and/or deleted at any time.

package factory

import (
	"context"

	models "github.com/AlienList/backend-watchlist/bob"
	"github.com/aarondl/opt/null"
	"github.com/aarondl/opt/omit"
	"github.com/aarondl/opt/omitnull"
	"github.com/google/uuid"
	"github.com/jaswdr/faker"
	"github.com/stephenafamo/bob"
)

type WatchlistMod interface {
	Apply(*WatchlistTemplate)
}

type WatchlistModFunc func(*WatchlistTemplate)

func (f WatchlistModFunc) Apply(n *WatchlistTemplate) {
	f(n)
}

type WatchlistModSlice []WatchlistMod

func (mods WatchlistModSlice) Apply(n *WatchlistTemplate) {
	for _, f := range mods {
		f.Apply(n)
	}
}

// WatchlistTemplate is an object representing the database table.
// all columns are optional and should be set by mods
type WatchlistTemplate struct {
	ID                func() uuid.UUID
	AnimeID           func() int
	UserID            func() uuid.UUID
	Ratings           func() null.Val[int]
	Status            func() null.Val[string]
	AiringAt          func() null.Val[int]
	NextAiringEpisode func() null.Val[int]

	r watchlistR
	f *Factory
}

type watchlistR struct {
	Anime *watchlistRAnimeR
	User  *watchlistRUserR
}

type watchlistRAnimeR struct {
	o *AnimeTemplate
}
type watchlistRUserR struct {
	o *UserTemplate
}

// Apply mods to the WatchlistTemplate
func (o *WatchlistTemplate) Apply(mods ...WatchlistMod) {
	for _, mod := range mods {
		mod.Apply(o)
	}
}

// toModel returns an *models.Watchlist
// this does nothing with the relationship templates
func (o WatchlistTemplate) toModel() *models.Watchlist {
	m := &models.Watchlist{}

	if o.ID != nil {
		m.ID = o.ID()
	}
	if o.AnimeID != nil {
		m.AnimeID = o.AnimeID()
	}
	if o.UserID != nil {
		m.UserID = o.UserID()
	}
	if o.Ratings != nil {
		m.Ratings = o.Ratings()
	}
	if o.Status != nil {
		m.Status = o.Status()
	}
	if o.AiringAt != nil {
		m.AiringAt = o.AiringAt()
	}
	if o.NextAiringEpisode != nil {
		m.NextAiringEpisode = o.NextAiringEpisode()
	}

	return m
}

// toModels returns an models.WatchlistSlice
// this does nothing with the relationship templates
func (o WatchlistTemplate) toModels(number int) models.WatchlistSlice {
	m := make(models.WatchlistSlice, number)

	for i := range m {
		m[i] = o.toModel()
	}

	return m
}

// setModelRels creates and sets the relationships on *models.Watchlist
// according to the relationships in the template. Nothing is inserted into the db
func (t WatchlistTemplate) setModelRels(o *models.Watchlist) {
	if t.r.Anime != nil {
		rel := t.r.Anime.o.toModel()
		rel.R.Watchlists = append(rel.R.Watchlists, o)
		o.AnimeID = rel.ID
		o.R.Anime = rel
	}

	if t.r.User != nil {
		rel := t.r.User.o.toModel()
		rel.R.Watchlists = append(rel.R.Watchlists, o)
		o.UserID = rel.UserID
		o.R.User = rel
	}

}

// BuildSetter returns an *models.WatchlistSetter
// this does nothing with the relationship templates
func (o WatchlistTemplate) BuildSetter() *models.WatchlistSetter {
	m := &models.WatchlistSetter{}

	if o.ID != nil {
		m.ID = omit.From(o.ID())
	}
	if o.AnimeID != nil {
		m.AnimeID = omit.From(o.AnimeID())
	}
	if o.UserID != nil {
		m.UserID = omit.From(o.UserID())
	}
	if o.Ratings != nil {
		m.Ratings = omitnull.FromNull(o.Ratings())
	}
	if o.Status != nil {
		m.Status = omitnull.FromNull(o.Status())
	}
	if o.AiringAt != nil {
		m.AiringAt = omitnull.FromNull(o.AiringAt())
	}
	if o.NextAiringEpisode != nil {
		m.NextAiringEpisode = omitnull.FromNull(o.NextAiringEpisode())
	}

	return m
}

// BuildManySetter returns an []*models.WatchlistSetter
// this does nothing with the relationship templates
func (o WatchlistTemplate) BuildManySetter(number int) []*models.WatchlistSetter {
	m := make([]*models.WatchlistSetter, number)

	for i := range m {
		m[i] = o.BuildSetter()
	}

	return m
}

// Build returns an *models.Watchlist
// Related objects are also created and placed in the .R field
// NOTE: Objects are not inserted into the database. Use WatchlistTemplate.Create
func (o WatchlistTemplate) Build() *models.Watchlist {
	m := o.toModel()
	o.setModelRels(m)

	return m
}

// BuildMany returns an models.WatchlistSlice
// Related objects are also created and placed in the .R field
// NOTE: Objects are not inserted into the database. Use WatchlistTemplate.CreateMany
func (o WatchlistTemplate) BuildMany(number int) models.WatchlistSlice {
	m := make(models.WatchlistSlice, number)

	for i := range m {
		m[i] = o.Build()
	}

	return m
}

func ensureCreatableWatchlist(m *models.WatchlistSetter) {
	if m.AnimeID.IsUnset() {
		m.AnimeID = omit.From(random[int](nil))
	}
	if m.UserID.IsUnset() {
		m.UserID = omit.From(random[uuid.UUID](nil))
	}
}

// insertOptRels creates and inserts any optional the relationships on *models.Watchlist
// according to the relationships in the template.
// any required relationship should have already exist on the model
func (o *WatchlistTemplate) insertOptRels(ctx context.Context, exec bob.Executor, m *models.Watchlist) (context.Context, error) {
	var err error

	return ctx, err
}

// Create builds a watchlist and inserts it into the database
// Relations objects are also inserted and placed in the .R field
func (o *WatchlistTemplate) Create(ctx context.Context, exec bob.Executor) (*models.Watchlist, error) {
	_, m, err := o.create(ctx, exec)
	return m, err
}

// create builds a watchlist and inserts it into the database
// Relations objects are also inserted and placed in the .R field
// this returns a context that includes the newly inserted model
func (o *WatchlistTemplate) create(ctx context.Context, exec bob.Executor) (context.Context, *models.Watchlist, error) {
	var err error
	opt := o.BuildSetter()
	ensureCreatableWatchlist(opt)

	var rel0 *models.Anime
	if o.r.Anime == nil {
		var ok bool
		rel0, ok = animeCtx.Value(ctx)
		if !ok {
			WatchlistMods.WithNewAnime().Apply(o)
		}
	}
	if o.r.Anime != nil {
		ctx, rel0, err = o.r.Anime.o.create(ctx, exec)
		if err != nil {
			return ctx, nil, err
		}
	}
	opt.AnimeID = omit.From(rel0.ID)

	var rel1 *models.User
	if o.r.User == nil {
		var ok bool
		rel1, ok = userCtx.Value(ctx)
		if !ok {
			WatchlistMods.WithNewUser().Apply(o)
		}
	}
	if o.r.User != nil {
		ctx, rel1, err = o.r.User.o.create(ctx, exec)
		if err != nil {
			return ctx, nil, err
		}
	}
	opt.UserID = omit.From(rel1.UserID)

	m, err := models.Watchlists.Insert(ctx, exec, opt)
	if err != nil {
		return ctx, nil, err
	}
	ctx = watchlistCtx.WithValue(ctx, m)

	m.R.Anime = rel0
	m.R.User = rel1

	ctx, err = o.insertOptRels(ctx, exec, m)
	return ctx, m, err
}

// CreateMany builds multiple watchlists and inserts them into the database
// Relations objects are also inserted and placed in the .R field
func (o WatchlistTemplate) CreateMany(ctx context.Context, exec bob.Executor, number int) (models.WatchlistSlice, error) {
	_, m, err := o.createMany(ctx, exec, number)
	return m, err
}

// createMany builds multiple watchlists and inserts them into the database
// Relations objects are also inserted and placed in the .R field
// this returns a context that includes the newly inserted models
func (o WatchlistTemplate) createMany(ctx context.Context, exec bob.Executor, number int) (context.Context, models.WatchlistSlice, error) {
	var err error
	m := make(models.WatchlistSlice, number)

	for i := range m {
		ctx, m[i], err = o.create(ctx, exec)
		if err != nil {
			return ctx, nil, err
		}
	}

	return ctx, m, nil
}

// Watchlist has methods that act as mods for the WatchlistTemplate
var WatchlistMods watchlistMods

type watchlistMods struct{}

func (m watchlistMods) RandomizeAllColumns(f *faker.Faker) WatchlistMod {
	return WatchlistModSlice{
		WatchlistMods.RandomID(f),
		WatchlistMods.RandomAnimeID(f),
		WatchlistMods.RandomUserID(f),
		WatchlistMods.RandomRatings(f),
		WatchlistMods.RandomStatus(f),
		WatchlistMods.RandomAiringAt(f),
		WatchlistMods.RandomNextAiringEpisode(f),
	}
}

// Set the model columns to this value
func (m watchlistMods) ID(val uuid.UUID) WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		o.ID = func() uuid.UUID { return val }
	})
}

// Set the Column from the function
func (m watchlistMods) IDFunc(f func() uuid.UUID) WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		o.ID = f
	})
}

// Clear any values for the column
func (m watchlistMods) UnsetID() WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		o.ID = nil
	})
}

// Generates a random value for the column using the given faker
// if faker is nil, a default faker is used
func (m watchlistMods) RandomID(f *faker.Faker) WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		o.ID = func() uuid.UUID {
			return random[uuid.UUID](f)
		}
	})
}

func (m watchlistMods) ensureID(f *faker.Faker) WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		if o.ID != nil {
			return
		}

		o.ID = func() uuid.UUID {
			return random[uuid.UUID](f)
		}
	})
}

// Set the model columns to this value
func (m watchlistMods) AnimeID(val int) WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		o.AnimeID = func() int { return val }
	})
}

// Set the Column from the function
func (m watchlistMods) AnimeIDFunc(f func() int) WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		o.AnimeID = f
	})
}

// Clear any values for the column
func (m watchlistMods) UnsetAnimeID() WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		o.AnimeID = nil
	})
}

// Generates a random value for the column using the given faker
// if faker is nil, a default faker is used
func (m watchlistMods) RandomAnimeID(f *faker.Faker) WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		o.AnimeID = func() int {
			return random[int](f)
		}
	})
}

func (m watchlistMods) ensureAnimeID(f *faker.Faker) WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		if o.AnimeID != nil {
			return
		}

		o.AnimeID = func() int {
			return random[int](f)
		}
	})
}

// Set the model columns to this value
func (m watchlistMods) UserID(val uuid.UUID) WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		o.UserID = func() uuid.UUID { return val }
	})
}

// Set the Column from the function
func (m watchlistMods) UserIDFunc(f func() uuid.UUID) WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		o.UserID = f
	})
}

// Clear any values for the column
func (m watchlistMods) UnsetUserID() WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		o.UserID = nil
	})
}

// Generates a random value for the column using the given faker
// if faker is nil, a default faker is used
func (m watchlistMods) RandomUserID(f *faker.Faker) WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		o.UserID = func() uuid.UUID {
			return random[uuid.UUID](f)
		}
	})
}

func (m watchlistMods) ensureUserID(f *faker.Faker) WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		if o.UserID != nil {
			return
		}

		o.UserID = func() uuid.UUID {
			return random[uuid.UUID](f)
		}
	})
}

// Set the model columns to this value
func (m watchlistMods) Ratings(val null.Val[int]) WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		o.Ratings = func() null.Val[int] { return val }
	})
}

// Set the Column from the function
func (m watchlistMods) RatingsFunc(f func() null.Val[int]) WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		o.Ratings = f
	})
}

// Clear any values for the column
func (m watchlistMods) UnsetRatings() WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		o.Ratings = nil
	})
}

// Generates a random value for the column using the given faker
// if faker is nil, a default faker is used
func (m watchlistMods) RandomRatings(f *faker.Faker) WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		o.Ratings = func() null.Val[int] {
			return randomNull[int](f)
		}
	})
}

func (m watchlistMods) ensureRatings(f *faker.Faker) WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		if o.Ratings != nil {
			return
		}

		o.Ratings = func() null.Val[int] {
			return randomNull[int](f)
		}
	})
}

// Set the model columns to this value
func (m watchlistMods) Status(val null.Val[string]) WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		o.Status = func() null.Val[string] { return val }
	})
}

// Set the Column from the function
func (m watchlistMods) StatusFunc(f func() null.Val[string]) WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		o.Status = f
	})
}

// Clear any values for the column
func (m watchlistMods) UnsetStatus() WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		o.Status = nil
	})
}

// Generates a random value for the column using the given faker
// if faker is nil, a default faker is used
func (m watchlistMods) RandomStatus(f *faker.Faker) WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		o.Status = func() null.Val[string] {
			return randomNull[string](f)
		}
	})
}

func (m watchlistMods) ensureStatus(f *faker.Faker) WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		if o.Status != nil {
			return
		}

		o.Status = func() null.Val[string] {
			return randomNull[string](f)
		}
	})
}

// Set the model columns to this value
func (m watchlistMods) AiringAt(val null.Val[int]) WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		o.AiringAt = func() null.Val[int] { return val }
	})
}

// Set the Column from the function
func (m watchlistMods) AiringAtFunc(f func() null.Val[int]) WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		o.AiringAt = f
	})
}

// Clear any values for the column
func (m watchlistMods) UnsetAiringAt() WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		o.AiringAt = nil
	})
}

// Generates a random value for the column using the given faker
// if faker is nil, a default faker is used
func (m watchlistMods) RandomAiringAt(f *faker.Faker) WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		o.AiringAt = func() null.Val[int] {
			return randomNull[int](f)
		}
	})
}

func (m watchlistMods) ensureAiringAt(f *faker.Faker) WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		if o.AiringAt != nil {
			return
		}

		o.AiringAt = func() null.Val[int] {
			return randomNull[int](f)
		}
	})
}

// Set the model columns to this value
func (m watchlistMods) NextAiringEpisode(val null.Val[int]) WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		o.NextAiringEpisode = func() null.Val[int] { return val }
	})
}

// Set the Column from the function
func (m watchlistMods) NextAiringEpisodeFunc(f func() null.Val[int]) WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		o.NextAiringEpisode = f
	})
}

// Clear any values for the column
func (m watchlistMods) UnsetNextAiringEpisode() WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		o.NextAiringEpisode = nil
	})
}

// Generates a random value for the column using the given faker
// if faker is nil, a default faker is used
func (m watchlistMods) RandomNextAiringEpisode(f *faker.Faker) WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		o.NextAiringEpisode = func() null.Val[int] {
			return randomNull[int](f)
		}
	})
}

func (m watchlistMods) ensureNextAiringEpisode(f *faker.Faker) WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		if o.NextAiringEpisode != nil {
			return
		}

		o.NextAiringEpisode = func() null.Val[int] {
			return randomNull[int](f)
		}
	})
}

func (m watchlistMods) WithAnime(rel *AnimeTemplate) WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		o.r.Anime = &watchlistRAnimeR{
			o: rel,
		}
	})
}

func (m watchlistMods) WithNewAnime(mods ...AnimeMod) WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {

		related := o.f.NewAnime(mods...)

		m.WithAnime(related).Apply(o)
	})
}

func (m watchlistMods) WithoutAnime() WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		o.r.Anime = nil
	})
}

func (m watchlistMods) WithUser(rel *UserTemplate) WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		o.r.User = &watchlistRUserR{
			o: rel,
		}
	})
}

func (m watchlistMods) WithNewUser(mods ...UserMod) WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {

		related := o.f.NewUser(mods...)

		m.WithUser(related).Apply(o)
	})
}

func (m watchlistMods) WithoutUser() WatchlistMod {
	return WatchlistModFunc(func(o *WatchlistTemplate) {
		o.r.User = nil
	})
}
